﻿@page "/system-compartment-detail/{PageModeName}"
@page "/system-compartment-detail/{PageModeName}/{Id:int}"
@inject HttpClient HttpClient
@inject ISnackbar Snackbar
@inject NavigationManager NavigationManager

<PageTitle Title=@($"システム区分詳細({pageMode.DisplayValue})") />

<EditForm Model="@systemCompartment" OnValidSubmit="OnValidSubmit" class="mt-2">
    <DataAnnotationsValidator />
    <MudCard>
        <MudCardContent>
            <MudItem xs="12" sm="6" md="4">
                <MudTextField Label="@systemCompartment.GetDisplayName(s => s.Compartment)"
                              @bind-Value="systemCompartment.Compartment"
                              For="@(() => systemCompartment.Compartment)"
                              ReadOnly="pageMode.IsReadOnly"
                              HelperText="@systemCompartment.GetDisplayDescription(s => s.Compartment)" HelperTextOnFocus="true" />
            </MudItem>
            <MudItem xs="12" sm="6" md="4">
                <MudTextField Label="@systemCompartment.GetDisplayName(s => s.CompartmentName)"
                              @bind-Value="systemCompartment.CompartmentName"
                              For="@(() => systemCompartment.CompartmentName)"
                              ReadOnly="pageMode.IsReadOnly" />
            </MudItem>
            <MudItem xs="12" sm="6" md="4">
                <MudTextField Label="@systemCompartment.GetDisplayName(s => s.Description)"
                              @bind-Value="systemCompartment.Description"
                              For="@(() => systemCompartment.Description)"
                              Lines="3"
                              ReadOnly="pageMode.IsReadOnly" />
            </MudItem>
            <MudItem xs="12" sm="6" md="4">
                <MudTextField Label="@systemCompartment.GetDisplayName(s => s.Remarks)"
                              @bind-Value="systemCompartment.Remarks"
                              For="@(() => systemCompartment.Remarks)"
                              Lines="3"
                              ReadOnly="pageMode.IsReadOnly" />
            </MudItem>
        </MudCardContent>
        <MudCardActions>
            @if (!pageMode.Equals(PageMode.Show))
            {
                <MudButton ButtonType="ButtonType.Submit" Variant="Variant.Filled" Color="@(pageMode.Equals(PageMode.Delete) ? Color.Secondary : Color.Primary)" Class="mr-4">@pageMode.DisplayValue</MudButton>
            }
            <MudButton Variant="Variant.Filled" Link="/system-compartment-list">戻る</MudButton>
        </MudCardActions>
    </MudCard>
</EditForm>

@code{
    [Parameter]
    public string PageModeName { get; set; }

    [Parameter]
    public int Id { get; set; }

    private PageMode pageMode = new(1);
    private SystemCompartmentEntity systemCompartment = new();

    protected override void OnParametersSet()
    {
        pageMode = new(PageModeName);
    }

    protected async override Task OnInitializedAsync()
    {
        if (Id != 0)
        {
            try
            {
                systemCompartment = await HttpClient.GetFromJsonAsync<SystemCompartmentEntity>($"api/SystemCompartments/{Id}");
            }
            catch (Exception ex)
            {
                Snackbar.Add(ex.Message, Severity.Success);
            }
        }
    }

    private async Task OnValidSubmit(EditContext context)
    {
        try
        {
            if (pageMode == PageMode.Create)
            {
                await HttpClient.PostAsJsonAsync<SystemCompartmentEntity>("api/SystemCompartments", systemCompartment);
            }
            else if (pageMode == PageMode.Edit)
            {
                await HttpClient.PutAsJsonAsync<SystemCompartmentEntity>($"api/SystemCompartments/{Id}", systemCompartment);
            }
            else if (pageMode == PageMode.Delete)
            {
                await HttpClient.DeleteAsync($"api/SystemCompartments/{Id}");
            }
        }
        catch (Exception)
        {
            throw;
        }

        NavigationManager.NavigateTo("/system-compartment-list");
        StateHasChanged();
    }
}